//*****************************************
// IV-21 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:Ad_conv.c
//
//  PC1(ADC1): CdS
//
// 2016/07/05
//  huPWQbknbj̃\[XύXAtBg쓮ǉĂhu|QPpƂ
//
//  2015/12/29 New
//  2016/07/05 modify     Taishi  IV-21pɕύX{tBg쓮ǉ
//*****************************************
#include				<avr/io.h>

#include				"iv21_clock.h"
#include				"Ad_conv.h"

#define					N_of_AD_data		16						// Q̊K̒lɌ

static	unsigned short	ad7_data[N_of_AD_data];
static	unsigned char	ad7_count;
static	unsigned char	ad7_conv_1;									// 1:ADC7 Convert running
// **********************************************************
// ************************** A/D 1 *************************
// **********************************************************

//*****************************************
// A/D 7 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//  ADC7: +24V (24 / 10)
//*****************************************
void	ad7_init(void)
{
	unsigned char	i;

	ad7_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad7_data[i] = 0;
	}


	PRR &= ~(1 << PRADC);																	// ADCғ
//	DIDR0 |= (1 << ADC7D);																	// AiO͐ݒ AD7 ͖

#if	FULL_VOLT100 ==	110																		// `^cdPDPu̎
	ADMUX = ( (1 << REFS1) | (1 << REFS0) | (0 << MUX3) | (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );		// PDPudgp, Select ADC7
#else
	ADMUX = ( (0 << REFS1) | (1 << REFS0) | (0 << MUX3) | (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );		// ubbdgp, Select ADC7
#endif
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS
	ad7_conv_1 = 1;																			// 1:ADC7 Convert running

}
//*****************************************
// A/D 7 close
//*****************************************
void	ad7_close(void)
{
	ADCSRA = 0;																				// A/Ds
	ad7_conv_1 = 0;																			// 0:ADC1 Convert Not running
}
//*****************************************
// A/D 7 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad7_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
		if( ad7_conv_1 != 0){										// ADC1 ϊ
			ad7_data[ad7_count] = ADCW;
			ad7_count++;
			ad7_count &= (N_of_AD_data - 1);
			ADMUX &= ( (1 << REFS1) | (1 << REFS0) );				// dwrbg͎c
			ADMUX |= ( (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );	// Select ADC6
		}

		ADCSRA |= (1 << ADSC);										// A/DϊJn
	}
}
//*****************************************
// A/D 7 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//*****************************************
unsigned short	ad7_get_data(void)
{
	unsigned char	i;
	unsigned short	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad7_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
