//*****************************************
// IV-21 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:Mega_spi.c
//
//  PB0(SS)  : SPI-SS i܂ł̂crRQRS̕ƈĂj
//  PB3(MOSI): SPI-MOSI(Mega88:out, DS3234:in)
//  PB4(MISO): SPI-MISO(Mega88:in,  DS3234:out)
//  PB5(SCT) : SPI-SCK
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
// 2016/07/05
//  huPWQbknbj̃\[XύXAtBg쓮ǉĂhu|QPpƂ
//
//  2015/12/29 New
//  2016/07/05 modify     Taishi  IV-21pɕύX{tBg쓮ǉ
//*****************************************

#include	<avr/io.h>

#include	"iv21_clock.h"
#include	"port_bit.h"
#include	"Mega_spi.h"


// ************************************
// SPI ݒ
//   @Ȃ
//  ߂l Ȃ
// ************************************
void	spi_init(void)
{
	// |[gݒ
	PORTB |= (1 << PB0);								// SS=H
	DDRB  |= ((1 << DDB0) | (1 << DDB3) | (1 << DDB5));	// SS,MOSI,SCK o͂ɂ
	DDRB  &= ~(1 << DDB4);								// MISO ͂ɂ

	// rohݒ
	PRR &= ~(1 << PRSPI);																		// SPIғ
	SPCR = ((1 << SPE) | (1 << MSTR) | (1 << CPOL) | (1 << CPHA) | (1 << SPR1) | (0 << SPR0));	// spiғA}X^[A[hRAfosc/64 = 125kHz
	SPSR = (0 << SPI2X);																		// fosc/64 = 125kHz

}

// ************************************
// SPI Jn
//     Ȃ
//  ߂l Ȃ
//
// ************************************
void	spi_start(void)
{
	PORTB &= ~(1 << PB0);								// SS=L
}

// ************************************
// SPI ~
//     Ȃ
//  ߂l Ȃ
//
// ************************************
void spi_stop(void)
{
	PORTB |= (1 << PB0);								// SS=H
}

// ************************************
// SPI ǂݏ
//     data: ݃f[^
//  ߂lFǏof[^
//
// ************************************
unsigned char	spi_rd_wr(unsigned char data)
{
	SPDR = data;							// ݃f[^ f[^WX^ɃZbg
	while ((SPSR & (1 << SPIF)) == 0){		// SPIF PɂȂ܂ő҂
		;
	}
	return(SPDR);
}
