//*******************************************************
// IV-21 VFD Clock Program Mega328
//  file name: disp_7seg_iv18.c
//@@@XVZOuecɃ_Ci~bN\
//@@@PD4:7seg.-BCD0             BCD R[hwi_j
//@@@PD5:7seg.-BCD1             BCD R[hwi_j
//@@@PD6:7seg.-BCD2             BCD R[hwi_j
//@@@PD7:7seg.-BCD3             BCD R[hwi_j
//@@@PC0:7seg.-a                1=Lighting
//@@@PC1:7seg.-b                1=Lighting
//@@@PC2:7seg.-c                1=Lighting
//@@@PC3:7seg.-d                1=Lighting
//@@@PC4:7seg.-e                1=Lighting
//@@@PC5:7seg.-f                1=Lighting
//@@@PB6:7seg.-g                1=Lighting
//@@@PB7:7seg.-dp               1=Lighting
//
// 2015/12/29
//  qsbQṼ\[X𗬗pāAVZOf[^ƌύXĂhu|PWpƂ

// 2016/07/05
//  huPWQbknbj̃\[XύXAtBg쓮ǉĂhu|QPpƂ
//
//  2015/12/29 New(TAB4)  Taishi
//  2016/07/05 modify     Taishi  IV-21pɕύX{tBg쓮ǉ
//*******************************************************

#include	<avr/io.h>

#include	"iv21_clock.h"
#include	"Ad_conv.h"
#include	"disp_7seg_iv21.h"

#define	SEG7_DUTY_MAX		6									// \Ԃɋ؂邩iݎԂƃ`cLŌ߂j
#define	SEG7_OFF_MAX		(SEG7_DUTY_MAX-1)					// \Ԓ̂neeɂ銄̍ől
#define	SEG7_OFF_MIN		0									// \Ԓ̂neeɂ銄̍ŏl
#define	SEG7_OFF_HIGH		SEG7_OFF_MAX						// \Ԗ邭鎞
#define	SEG7_OFF_MID		3									// \𒆂炢鎞
#define	SEG7_OFF_LOW		0									// \ԈÂ鎞

static	unsigned char	seg7_enable = 0;						// 0=VZO\Ȃ
static	unsigned char	seg7_off_duty = SEG7_OFF_HIGH;			// \Ԓ̂neeɂ銄i邳ςj
static	unsigned char	filament_st = 0;						// tBg̏ԁ@]^t]

static	unsigned char	seg7_data[KETA_MAX] ={0,0,0,0,0,0,0,0,0};	// \Vf[^

static	const unsigned char	hex_to_7seg[16]={
		// D7;dp, D6:g, D5:f, D4:e, D3:d, D2:c, D1:b, D0:a
		0b00111111,				// 0
		0b00000110,				// 1
		0b01011011,				// 2
		0b01001111,				// 3
		0b01100110,				// 4
		0b01101101,				// 5
		0b01111101,				// 6
		0b00000111,				// 7
		0b01111111,				// 8
		0b01101111,				// 9
		0b01110111,				// A
		0b01111100,				// B
		0b01011000,				// C
		0b01011110,				// D
		0b01111001,				// E
		0b01110001,				// F
};
static	const unsigned char	minus_7seg = 0b01000000;		// -
static	const unsigned char	equal_7seg = 0b01001000;		// =

// *****************************
//  VZOp̏ݒ
//  @ Ȃ
//
//  |[g(rbg)ݒ肷
//@@@XVZOuecɃ_Ci~bN\
//@@@PD4:7seg.-BCD0             BCD R[hwi_j
//@@@PD5:7seg.-BCD1             BCD R[hwi_j
//@@@PD6:7seg.-BCD2             BCD R[hwi_j
//@@@PD7:7seg.-BCD3             BCD R[hwi_j
//@@@PC0:7seg.-a                1=Lighting
//@@@PC1:7seg.-b                1=Lighting
//@@@PC2:7seg.-c                1=Lighting
//@@@PC3:7seg.-d                1=Lighting
//@@@PC4:7seg.-e                1=Lighting
//@@@PC5:7seg.-f                1=Lighting
//@@@PB6:7seg.-g                1=Lighting
//@@@PB7:7seg.-dp               1=Lighting
//  2015/12/29 New   Taishi
//  2016/08/08 Modify Taishi
// *****************************
void	init_7seg(void)
{
	PORTB |= ((1 << PB1) | (1 << PB2) );															// tBgFOUT1=L OUT2=Li~j
	DDRB  |= ((1 << DDB1) | (1 << DDB2) );															// tBg̃rbgo͂ɂ
	filament_st = 0;																				// tBg̏ԁ@]^t]

	DDRB  |= ((1 << DDB6) | (1 << DDB7) );															// ZOg̃rbgo͂ɂ
	PORTB &= ~((1 << PB6) | (1 << PB7) );															// ZOgf[^FLij
	DDRC  |= ((1 << DDC0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) );	// ZOg̃rbgo͂ɂ
	PORTC &= ~((1 << PC0) | (1 << PC1) | (1 << PC2) | (1 << PC3) | (1 << PC4) | (1 << PC5) );		// ZOgf[^Fgij
	DDRD  |= ((1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7) );								// R̃rbgo͂ɂ
	PORTD |= ((1 << PD4) | (1 << PD5) | (1 << PD6) | (1 << PD7) );									// Rf[^FPTo͂Ŗf[^ɂij

	seg7_enable = 0;																				// 0=VZO\Ȃ
}
// *****************************
//  VZO\̗L̃Zbg
// *****************************
void	set_7seg_enable(void)
{
	seg7_enable = 1;				// VZO\s
}
// *****************************
//  VZO\̖̃Zbg
// *****************************
void	set_7seg_disable(void)
{
	seg7_enable = 0;				// VZO\sȂ
}
// *****************************
//  VZOf[^̃Zbg
//  @
//@@@@FPUiiO`PTAPUȏ̓uNAA@Qcǵf|f\@Rcǵff\j
//@@@F̏ԁ@OAP_
//@@@@FwiO`WAOōj
//
//  2015/12/29 New   Taishi
// *****************************
void set_7seg_data(unsigned char h, unsigned char dp, unsigned char n)
{
	unsigned char	seg;

	if(h == 0x2d){
		seg = minus_7seg;				// }CiX\
	}else if(h == 0x3d){
		seg = equal_7seg;				// CR[\
	}else if(16 <= h){
		seg = 0;						// uN
	}else{
		seg = hex_to_7seg[h & 0x0f];	// PUiVZOf[^ɕϊ
	}
	if(dp != 0){
		if(n == 0){						// ō̎ ۂZOɓ
			seg |=  0x20;				// ǉ
		}else{
			seg |= 0x80;				// ǉ
		}
	}

	seg7_data[n % KETA_MAX] = seg;		// \Vf[^ɓ

}
// *****************************
//  VZOf[^֕ϊX
//  @
//@@@@strFX̂PUiiO`PTj̃|C^[
//@@@@ dpFX̂ỉEj̃|C^[
//
//@@X̂PUi͉SrbgL
//  2015/12/29 New   Taishi
// *****************************
void	chang_7seg_data(unsigned char *str,unsigned char *dp)
{
	unsigned char	i;

	for(i=0;i<KETA_MAX;i++){
		set_7seg_data(*(str+i), *(dp+i), i);		//  VZOf[^̃Zbg
	}
}
// *****************************
// ZOgf[^̒ڃZbg
//  @
//@@FZOgf[^
//@@@@FwiO`WAOj
//
//  2015/12/29 New   Taishi
// *****************************
void	set_segmet_direct(unsigned char seg,unsigned char n)
{
	seg7_data[n % KETA_MAX] = seg;		// \Vf[^ɓ
}
// *****************************
//  VZOf[^̂𒼐ڃZbg
//  @
//@@@F̏ԁ@OAP_
//@@@@FwiO`WAOj
//
//  2015/12/29 New   Taishi
// *****************************
void	set_7seg_dp(unsigned char dp, unsigned char n)
{
	if(n == 0){										// ō̎ ۂZOɓ
		if(dp == 0){
			seg7_data[0] &= ~0x20;					// 
		}else{
			seg7_data[0] |=  0x20;					// _
		}
	}else{
		if(dp == 0){
			seg7_data[n % KETA_MAX] &= ~0x80;		// 
		}else{
			seg7_data[n % KETA_MAX] |=  0x80;		// _
		}
	}
}

// *****************************
//  VZȌo
//  @
//@@@@FZOgf[^
//                D7;dp, D6:g, D5:f, D4:e, D3:d, D2:c, D1:b, D0:a
//
//  \߃|[g̐ݒ͍sĂ̂Ƃ
//  ZOgf[^̓n[h̓_A̘_ƈvĂ镨Ƃ
//@@@PC0:7seg.-a                1=Lighting
//@@@PC1:7seg.-b                1=Lighting
//@@@PC2:7seg.-c                1=Lighting
//@@@PC3:7seg.-d                1=Lighting
//@@@PC4:7seg.-e                1=Lighting
//@@@PC5:7seg.-f                1=Lighting
//@@@PB6:7seg.-g                1=Lighting
//@@@PB7:7seg.-dp               1=Lighting
//  2015/12/29 New   Taishi
// *****************************
static
void output_7seg(unsigned char seg)
{
	unsigned char	uc;

	PORTB &= ~( (1 << PB6) | (1 << PB7) );									// xSď̏Ԃɂ
	PORTC &= ~( (1 << PC0) | (1 << PC1) | (1 << PC2) | (1 << PC3) | (1 << PC4) | (1 << PC5) );

	uc = ( seg & ~((1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5)) );	// oâVZOf[^ɂ
	PORTB |= uc;															// oaɂ

	uc = ( seg & ~(1 << PC6) );												// ob̂VZOf[^ɂ
	PORTC |= uc;															// obɂ

}

// *****************************
//  VZO̕\
//  K莞(200uS -- 1mS)̊荞ݒŌĂ΂镨Ƃ
//@@@PD4:7seg.-BCD0             BCD R[hwi_j
//@@@PD5:7seg.-BCD1             BCD R[hwi_j
//@@@PD6:7seg.-BCD2             BCD R[hwi_j
//@@@PD7:7seg.-BCD3             BCD R[hwi_j
//  2015/12/29 New   Taishi
// *****************************
void	disp_7seg(void)
{
	static	unsigned char	keta=0;
	static	unsigned char	pre_scale=0;
	static	unsigned char	dig_bit[KETA_MAX]={0x8f,0x7f,0x6f,0x5f,0x4f,0x3f,0x2f,0x1f,0x0f};	// ɑΉabcR[hiʂSrbgj

	if((SEG7_DUTY_MAX-1) <= pre_scale){
		if(seg7_enable != 0){
			PORTD |= ((1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7));		// xRSĂneeɂ
			output_7seg(seg7_data[keta]);								// VZȌo
			PORTD &= dig_bit[keta];										// Rnm
			keta++;														// i߂
			keta %= KETA_MAX;

			pre_scale = 0;
		}
	}else{
		if(seg7_off_duty <= pre_scale){
			if(seg7_enable != 0){
				PORTD |= ((1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7));		// RSĂneeɂ
			}
		}
		pre_scale++;
	}
}

// *****************************
//@`FbNpɃCŌw肵Đo͂
// 
//  @
//@@@@FPUiiO`PTAW܂łL@Xȏ̓uNj
//@@@F̏ԁ@OAP_
//@@@@FwiO`WAOōj
//
//  2015/12/29 New   Taishi
// *****************************
void	chk_disp_7seg(unsigned char h, unsigned char dp, unsigned char n)
{
	static	unsigned char	d_bit[KETA_MAX]={0x8f,0x7f,0x6f,0x5f,0x4f,0x3f,0x2f,0x1f,0x0f};			// ɑΉabcR[hiʂSrbgj

	PORTD |= ((1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7));		// xRSĂneeɂ
	if((h == 0)&&(n == 0)){
		h = '-';
	}
	set_7seg_data(h, dp, n);
	output_7seg(seg7_data[n]);								// VZȌo
	PORTD &= d_bit[n];										// Rnm

}

// *****************************
//  tBg̑
//  POrɊ荞ݒŌĂ΂镨Ƃ
//@@@PB1:Fin
//@@@PB2:Rin
//  2016/07/05 New   Taishi
// *****************************
void	proc_filament(void)
{
	if(filament_st == 0){						// tBg̏ԁ@]
		PORTB |= (1 << PB1);					// PB1:1(FIN)
		PORTB &= ~(1 << PB2);					// PB2:0(RIN)
	}else{										// tBg̏ԁ@t]
		PORTB &= ~(1 << PB1);					// PB1:0(FIN)
		PORTB |= (1 << PB2);					// PB2:1(RIN)
	}
}
